/**
 *  Swing basierter Datums-Diffrenzrechner , der die Differenz eines Datums zum heutigen
 *  Tag in Tagen bestimmt. (edays - eighty days)
 *  Version 1.2	gehde@ag-intra.net
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.text.*;

public class Edays extends JFrame {
	// ***** Erstmal die Komponenten definieren, auf die zugegriffen wird
	JDateField eingabeFeld;

	JLabel ausgabeLabel;
	JLabel gueltigLabel;
	JLabel stichtagLabel;
	JLabel heuteLabel;
	JLabel statusLabel;

	Timer myTimer;

	Keymap myKeymap;
	KeyStroke myStroke;

	Calendar meinDatum = new GregorianCalendar();		//Daten die im Ablauf bentigt werden
	Calendar stichtag = new GregorianCalendar();
	Calendar heute = new GregorianCalendar();
	SimpleDateFormat datumsFormat = new SimpleDateFormat ("dd.MM.yyyy");
	DateDifferenceInDays myDate = new DateDifferenceInDays(	//DatumsdifferenzRechnerObjekt
			meinDatum.get(Calendar.DATE)-1,
			meinDatum.get(Calendar.MONTH)-1, 										meinDatum.get(Calendar.YEAR));


	public Edays() {					// **** Konstruktor
		super("eDays 1.2");

		getContentPane().setLayout(new BorderLayout(5,5)); //5 Pixel Abstand zw. Komponenten
		
		// Zwei Seperators
		JSeparator myUpperLine = new JSeparator();
		JSeparator myCenterLine = new JSeparator();

		// Ueberschrift
		JLabel myTitle = new JLabel("eighty Days",JLabel.CENTER);	//Alle Elemente
		myTitle.setFont(new Font("Helvetica",Font.BOLD,20));		//initialisieren
		myTitle.setForeground(Color.black);

		// meinDatum Beschriftung
		JLabel myDateFieldLabel = new JLabel("Datum:   ",JLabel.RIGHT);
		myDateFieldLabel.setFont(new Font("Helvetica",Font.BOLD,12));
		myDateFieldLabel.setForeground(Color.black);

		// Alter Beschriftung
		JLabel myErgebnisLabel = new JLabel("Alter in Tagen:   ",JLabel.RIGHT);
		myErgebnisLabel.setFont(new Font("Helvetica",Font.BOLD,12));
		myErgebnisLabel.setForeground(Color.black);

		// Gltigkeits Beschriftung
		JLabel myGueltigLabel = new JLabel("Stichtag dazu:   ",JLabel.RIGHT);
		myGueltigLabel.setFont(new Font("Helvetica",Font.BOLD,12));
		myGueltigLabel.setForeground(Color.black);

		// Gltigkeit fr das konkrete Datum Beschriftung
		JLabel myStichtagLabel = new JLabel("Stichtag dazu:   ",JLabel.RIGHT);
		myStichtagLabel.setFont(new Font("Helvetica",Font.BOLD,12));
		myStichtagLabel.setForeground(Color.black);

		// Heutiges Datum Beschriftung
		JLabel myHeuteLabel = new JLabel("Datum heute:   ",JLabel.RIGHT);
		myHeuteLabel.setFont(new Font("Helvetica",Font.BOLD,12));
		myHeuteLabel.setForeground(Color.black);

		// Statusfeld Beschriftung
		JLabel myStatusLabel = new JLabel("Status: ",JLabel.CENTER);
		myStatusLabel.setFont(new Font("Helvetica",Font.BOLD,12));
		myStatusLabel.setForeground(Color.black);

		// Eingabefeld Datum
		eingabeFeld = new JDateField(8); //Verwendet meine Version von DateField
		eingabeFeld.setHorizontalAlignment(JTextField.LEFT);
		eingabeFeld.setFont(new Font("Helvetica",Font.BOLD,14));

		// Fuer das Datumsfeld die Returntaste manipulieren, so das [return] 
		// die Aktion des buttons auslst
		myKeymap = eingabeFeld.getKeymap();
		myStroke = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0);	
		myKeymap.removeKeyStrokeBinding(myStroke);

		// Ausgabe Feld fuer die Differenz
		ausgabeLabel = new JLabel("00000",JLabel.LEFT);
		ausgabeLabel.setForeground(Color.black);
		ausgabeLabel.setFont(new Font("Helvetica",Font.BOLD,24));

		// Ausgabe Feld fuer das noch gltige Datum
		stichtag.add(Calendar.DATE, -80);
		String dateString = datumsFormat.format(stichtag.getTime());
		gueltigLabel = new JLabel(dateString, JLabel.LEFT);
		gueltigLabel.setForeground(Color.black);
		gueltigLabel.setFont(new Font("Helvetica",Font.BOLD,12));

		// Ausgabe Feld fuer den Stichtag zum aktuellen Datum
		stichtag.setTime(new Date());
		stichtag.add(Calendar.DATE, 80);
		dateString = datumsFormat.format(stichtag.getTime());
		stichtagLabel = new JLabel(dateString, JLabel.LEFT);
		stichtagLabel.setForeground(Color.black);
		stichtagLabel.setFont(new Font("Helvetica",Font.BOLD,12));

		// Ausgabe Feld fuer das aktuelle Datum
		dateString = datumsFormat.format(heute.getTime());
		heuteLabel = new JLabel(dateString, JLabel.LEFT);
		heuteLabel.setForeground(Color.black);
		heuteLabel.setFont(new Font("Helvetica",Font.BOLD,12));

		// Ausgabe Feld fuer den Status
		statusLabel = new JLabel("Berechnung durchgefhrt",JLabel.LEFT);
		statusLabel.setForeground(Color.black);
		statusLabel.setFont(new Font("Helvetica",Font.BOLD,12));

		// Panels definieren und Layout setzen
		JPanel topPanel = new JPanel();
		JPanel centerPanel = new JPanel();
		JPanel footerPanel = new JPanel();
		JPanel upperGridPanel = new JPanel();
		JPanel middlePanel = new JPanel();
		JPanel lowerGridPanel = new JPanel();

		topPanel.setLayout(new BorderLayout()); 	//
		centerPanel.setLayout(new BorderLayout()); 	//3 Pixel Abstand zw. Komponenten
		footerPanel.setLayout(new FlowLayout(FlowLayout.LEFT)); //alles nacheinander
		upperGridPanel.setLayout(new GridLayout(3,2)); 	//2 zeilen 3 spalten
		middlePanel.setLayout(new BorderLayout(5,5)); 	// ohne abstand
		lowerGridPanel.setLayout(new GridLayout(2,2));
		footerPanel.setBorder(BorderFactory.createLoweredBevelBorder()); //Rahmen zeichnen

		// Button definieren und eigentliche Programmfunktion einbauen
		JButton berechne = new JButton("Berechnen");		// Ereignis Button-Click
		berechne.addActionListener(new ActionListener() {	// in anonymer Klasse
			public void actionPerformed(ActionEvent e) {
				int frist, tag=02, monat=11, jahr=2000; //Voreinstellung Datum
				boolean noDateError=true;

				if(eingabeFeld.hasNoZeroField()) {	//Prfen ob nicht leer
					tag = eingabeFeld.getDay();
					monat = eingabeFeld.getMonth()-1;
					jahr = eingabeFeld.getYear();
				}
				else {
					noDateError=false;
					statusLabel.setText("Kein Nullfeld mglich!");
					ausgabeLabel.setText("##");
				}
				
				meinDatum.set(jahr, monat, tag);	//Calenderobjekte aktualisieren
				heute.setTime(new Date());

				if(!meinDatum.before(heute)) {	//Prfen ob Datum in der Zukunft
					noDateError=false;
					statusLabel.setText("Datum in der Zukunft!");
					ausgabeLabel.setText("##");
				}
				if(!JDateField.isDate(tag, monat, jahr)) {
					noDateError=false;
					statusLabel.setText("Datum ungltig!");
					ausgabeLabel.setText("##");
				}
				if(noDateError) {
					myDate.setEarly(tag, monat, jahr);
					myDate.setLater(heute.get(Calendar.DATE),
							heute.get(Calendar.MONTH), 										heute.get(Calendar.YEAR));
					frist=myDate.getDifference();
					ausgabeLabel.setText(String.valueOf(frist));

					//aktuellen Stichtag Updaten
					stichtag.set(jahr, monat, tag);
					stichtag.add(Calendar.DATE, 80);
					String datumsString = datumsFormat.format(stichtag.getTime());
					stichtagLabel.setText(datumsString);
					statusLabel.setText("Berechnung durchgefhrt.");
				}
			}
		});
		SwingUtilities.getRootPane(this).setDefaultButton(berechne);

		//Timer fr die Anzeige des Stichtages zum heutigen Datum (alle 5 Minuten)
		myTimer = new Timer(300000, new ActionListener() {  //300000 Millisekunden
              		public void actionPerformed(ActionEvent evt) {
                  		stichtag.setTime(new Date());	// *** Stichtag
				stichtag.add(Calendar.DATE, -80);
				String datumsString = datumsFormat.format(stichtag.getTime());
				gueltigLabel.setText(datumsString);
				heute.setTime(new Date());	// *** Heute
				datumsString = datumsFormat.format(heute.getTime());
				heuteLabel.setText(datumsString);
              		}    
          	});

		// Aktive Komponenten ins UpperGrid einbauen
		upperGridPanel.add(myDateFieldLabel);
		upperGridPanel.add(eingabeFeld);
		upperGridPanel.add(myErgebnisLabel);
		upperGridPanel.add(ausgabeLabel);
		upperGridPanel.add(myStichtagLabel);
		upperGridPanel.add(stichtagLabel);
		
		// Berechnen Button und Linie ins Middel Panel
		middlePanel.add(berechne, BorderLayout.NORTH);
		middlePanel.add(myCenterLine, BorderLayout.SOUTH);

		// Gltigkeits Komponenten ins LowerGrid einbauen
		lowerGridPanel.add(myHeuteLabel);
		lowerGridPanel.add(heuteLabel);
		lowerGridPanel.add(myGueltigLabel);
		lowerGridPanel.add(gueltigLabel);		

		// berschrift ins Toppanel einbauen
		topPanel.add(myTitle, BorderLayout.NORTH);
		topPanel.add(myUpperLine, BorderLayout.SOUTH);

		// Status ins FooterPanel einbauen
		footerPanel.add(myStatusLabel);
		footerPanel.add(statusLabel);

		// Gridpanels ins bergeordnete Center Panel bauen
		centerPanel.add(upperGridPanel, BorderLayout.NORTH);
		centerPanel.add(middlePanel, BorderLayout.CENTER);
		centerPanel.add(lowerGridPanel, BorderLayout.SOUTH);

		// UnterPanels  in den Frame einbauen
		getContentPane().add(topPanel, BorderLayout.NORTH);
		getContentPane().add(centerPanel, BorderLayout.CENTER);
		getContentPane().add(footerPanel, BorderLayout.SOUTH);
	
		this.enableEvents(AWTEvent.WINDOW_EVENT_MASK); //Ereignisse ermglichen (Schlieen)
	}

	protected void processWindowEvent(WindowEvent e) {	// berschreiben um zu Beenden
		if (e.getID()==WindowEvent.WINDOW_CLOSING) { 
			dispose();                      	// Ressourcen des Fensters freigeben 
			System.exit(0);                 	// Programm beenden 
		} 
	} // Ende Methode processWindowEvent() 

	public static void main(String[] arg) {		//Hauptmethode
      		Edays myEdays = new Edays();
      		myEdays.pack();
      		myEdays.show();
		myEdays.ausgabeLabel.setText("0");
		myEdays.statusLabel.setText("Datum eingeben");
		myEdays.myTimer.start();
	}
}